#include "singlemodethread.h"
#include "qhyccd.h"
#include <QDateTime>
#include <cstdio>
#include <QDebug>
#include <QMutex>

extern qhyccd_handle *camhandle;

extern QMutex ShowImgMutex;

SingleModeThread::SingleModeThread(QObject *parent) :
    QThread(parent)
{

}

void SingleModeThread::run()
{
    uint32_t ret = QHYCCD_ERROR;

    while(ret == QHYCCD_ERROR)
    {
        ret = GetQHYCCDSingleFrame(camhandle, &CamInfo.ImgW, &CamInfo.ImgH, &CamInfo.ImgB, &CamInfo.ImgC, CamInfo.ImgData);
    }

    if(ShowImgMutex.tryLock())
    {
        memcpy(CamInfo.ShowImgData, CamInfo.ImgData, CamInfo.ImgW*CamInfo.ImgH*CamInfo.ImgB*CamInfo.ImgC/8);
        CamInfo.ShowImgW = CamInfo.ImgW;
        CamInfo.ShowImgH = CamInfo.ImgH;
        CamInfo.ShowImgB = CamInfo.ImgB;
        CamInfo.ShowImgC = CamInfo.ImgC;
        emit gotImageData();

        ShowImgMutex.unlock();
    }

    CamInfo.Frame ++;
}
